#include <windows.h>

#include "type.h"
#include "cd.h"
#include "Win32Def.h"
#include "resource.h"

#define VERSION     0x0100  // Version must be in BCD format

static FPSEWin32About info = {
    FPSE_CDROM,
    VERSION & 0xFF,
    VERSION >> 8,
    0,
    "LDChen",
    "CDCtrl",
    "This Plugin uses IOControl methods for reading CD-ROMs."
    "It can work only on NT4 and NT2000."
};

static HANDLE     hinstance = (HANDLE)-1;
static FPSEWin32 *infodb;
static UINT8      DriveList[16];
static int        NDrive;

BOOL WINAPI
#ifdef __GNUC__
LibMain
#else
DllMain
#endif
(HANDLE hInstance, DWORD fdwReason, PVOID fImpLoad)
{
    hinstance = hInstance;
    return TRUE;
}

static void ScanDrives(void)
{
    char path[4];

    strcpy(path,"A:");
    NDrive = 0;
    for ( ; path[0] <= 'Z' ; path[0]++)
        if (GetDriveType(path) == DRIVE_CDROM)
        {
            DriveList[NDrive] = path[0];
            NDrive++;
        }
}

#define COMBO       ((HWND)GetDlgItem(hwnd,IDC_COMBODRIVE))

BOOL CALLBACK ConfigDialogProc(HWND hwnd, UINT msg, WPARAM wPar, LPARAM lPar)
{
    char Letter[5];
    int  x;

    switch (msg) {
    case WM_INITDIALOG:
        ScanDrives();
        if (!NDrive)
            EnableWindow(COMBO, FALSE);
        else {
            Letter[1] = ':';
            Letter[2] = '\\';
            Letter[3] = 0;
            for (x=0;x<NDrive;x++)
            {
                Letter[0] = DriveList[x];

                SendMessage(COMBO,CB_ADDSTRING,0,(LONG)Letter);
            }

            SendMessage(COMBO,CB_SETCURSEL,0,0L);
        }
        return TRUE;

    case WM_DESTROY:
        EndDialog(hwnd,0);
        return TRUE;

    case WM_COMMAND:
        switch (wPar) {
        case IDOK:
            if (NDrive)
            {
                x = SendMessage(COMBO,CB_GETCURSEL,0,0L);

                Letter[0] = DriveList[x];
                Letter[1] = 0;
                infodb->WriteCfg("CDIOCTRL","DriveLetter",Letter);
            }
        case IDCANCEL:
            EndDialog(hwnd,0);
            return TRUE;
        }
    }

    return FALSE;
}

int CD_Configure(UINT32 *par)
{
    infodb = (FPSEWin32 *)par;

    DialogBox(hinstance,MAKEINTRESOURCE(IDD_DIALOG),
              infodb->HWnd,ConfigDialogProc);

    return FPSE_OK;
}

void CD_About(UINT32 *par)
{
    memcpy( par, &info, sizeof(FPSEWin32About) );
}
